---
layout: mockup
title: "System Monitor - Resources"
theme: Adwaita/Adwaita.css
permalink: system-monitor/resources
wallpaper: adwaita
---

{%- include widgets/_panel.html -%}
<!-- js -->
<script type="text/javascript" src="{{ site.baseurl }}/js/smoothie.js"></script>
<!-- css -->
<link rel="stylesheet" type="text/css" href="{{ site.baseurl }}/css/Adwaita/apps/system-monitor.css">

<!-- Window -->
<div class="window medium">
	<!-- Titlebar -->
	<div class="titlebar grouped">
		<!-- left button group -->
		<div class="button-group float-left">
		</div>
		<!-- center button group -->
		<div class="button-group float-center wide">
			<div class="linked stack-switcher">
				<a class="button text-button left">Performance</a><a class="button text-button pressed middle">Resources</a><a class="button text-button right">File Systems</a>
			</div>
		</div>
		<!-- right button group -->
		<div class="button-group float-right">
			<a class="button image-button" id="sysmonMenu">{%- include symbolic/actions/open-menu-symbolic.svg -%}</a>{%- include components/close-button.html close = "window" -%}
		</div>
	</div>
	<div class="content">
		<div class="view">
			<div class="row">
				<div class="text-center float-left" style="width: 50%;display: inline-block;">
					<div class="sysmonUsageRing"><img id="sysmonCPURing" src="{{ site.baseurl }}/img/system-monitor/cpu-ring.svg"></div>
					<!-- <div class="sysmonUsageRing"><img id="sysmonCPURing" src="{{ site.baseurl }}/img/system-monitor/cpu-ring-high.svg"></div> -->
					<h2>CPU</h2>
					<h3 class="monospace-label"><span style="color:rgba(51, 209, 122, 1);">&#9210;&nbsp;</span>Usage (37.5%)</h3>
					<!-- <h3 class="monospace-label warning-label"><span>&#9210;&nbsp;</span>Usage (90.9%)&nbsp; {%- include symbolic/status/dialog-warning-symbolic.svg -%}</h3> -->
				</div>
				<div class="text-center float-right" style="width: 50%;display: inline-block;">
					<div class="sysmonUsageRing"><img id="sysmonMemRing" src="{{ site.baseurl }}/img/system-monitor/mem-ring.svg"></div>
					<h2>Memory</h2>
					<h3 class="monospace-label"><span style="color:rgba(233, 77, 223, 1);">&#9210;&nbsp;</span>Physical (36.1%)<br><span style="color:rgba(53, 132, 228, 1);">&#9210;&nbsp;</span>Virtual (13.8%) </h3>
				</div>
			</div>
			<div class="row">
				<h4>Processor</h4>
				<ul class="listrow">
					<li style="padding: 0;height: 128px;" class="sysmonActivityCanvas" onclick="$('#processorDetailedViewDialog').show();">
						<span class="yAxisValueLabelTop">100%</span>
						<span class="yAxisValueLabelBottom">0%</span>
						<canvas id="host1Cpu" width="480" height="128"></canvas>
					</li>
					<li>
						<label class="monospace-label"><span style="color:rgba(53, 132, 228, 1);">&#9210;&nbsp;</span>CPU1</label>
						<label class="monospace-label"><span style="color:rgba(51, 209, 122, 1);">&#9210;&nbsp;</span>CPU2</label>
						<label class="monospace-label"><span style="color:rgba(255, 120, 0, 1);">&#9210;&nbsp;</span>CPU3</label>
						<label class="monospace-label"><span style="color:rgba(244, 27, 36, 1);">&#9210;&nbsp;</span>CPU4</label>
					</li>
				</ul>
				<a class="button text-button sysmonBusyButton" onclick="$(this).hide();sysmonCPUActivity();">Get Busy</a>
				<ul class="listrow">
					<li>
						<label>Processor</label>
						<label class="float-right dim-label">Intel &reg; Core &trade; i7 E5-2800</label>
					<li>
						<label>Cores</label>
						<label class="float-right dim-label">4 @ 2.60 GHz</label>
					</li>
				</ul>
			</div>
			<div class="row">
				<h4>Memory</h4>
				<ul class="listrow">
					<li style="padding: 0;height: 128px;" class="sysmonActivityCanvas" onclick="sysmonMemoryActivity();">
						<span class="yAxisValueLabelTop">100%</span>
						<span class="yAxisValueLabelBottom">0%</span>
						<canvas id="host1Memory" width="480" height="128"></canvas>
					</li>
					<li>
						<label class="monospace-label"><span style="color:rgba(233, 77, 223, 1);">&#9210;&nbsp;</span>Physical Memory</label>
						<label class="monospace-label"><span style="color:rgba(53, 132, 228, 1);">&#9210;&nbsp;</span>Virtual Memory</label>
					</li>
				</ul>
				<a class="button text-button sysmonBusyButton" onclick="$(this).hide();sysmonMemoryActivity();">Get Busy</a>
				<ul class="listrow">
					<li>
						<label>Physical Memory</label>
						<label class="float-right dim-label">16.0 GiB</label>
					</li>
					<li>
						<label>Memory Used</label>
						<label class="float-right dim-label">5.8 GiB (10.2 GiB available)</label> 
					</li>
				</ul>
				<ul class="listrow">
					<li>
						<label>Virtual Memory</label>
						<label class="float-right dim-label">32.0 GiB</label>
					</li>
					<li>
						<label>Swap Used</label>
						<label class="float-right dim-label">4.4 GiB (27.6 GiB available)</label> 
				</ul>
			</div>
			<div class="row">
				<h4>Networking</h4>
				<ul class="listrow">
					<li style="padding: 0;height: 128px;" class="sysmonActivityCanvas">
						<span class="yAxisValueLabelTop">15 MB/s</span>
						<span class="yAxisValueLabelBottom">0 B/s</span>
						<canvas id="host1Network" width="480" height="128"></canvas>
					</li>
					<li>
						<label class="monospace-label"><span style="color:rgba(244, 27, 36, 1);">&#9210;&nbsp;</span>Download (12.8 MB/s)</label>
						<label class="monospace-label"><span style="color:rgba(53, 132, 228, 1);">&#9210;&nbsp;</span>Upload (11.9 MB/s)</label>
					</li>
				</ul>
				<a class="button text-button sysmonBusyButton" onclick="$(this).hide();sysmonNetworkActivity();">Get Active</a>
				<ul class="listrow">
					<li>
						<label>Total Upload</label>
						<label class="float-right dim-label">12.2 GiB</label> 
					</li>
					<li>
						<label>Total Download</label>
						<label class="float-right dim-label">87.9 GiB</label> 
					</li>
				</ul>
			</div>
			<div class="row">
				<h4>System</h4>
				<ul class="listrow">
					<li>
						<label>Uptime</label>
						<label class="float-right dim-label">5 days 8 hours 27 minutes</label>
					</li>
					<!-- <li>
						<label>Battery Life</label>
						<label class="float-right dim-label">4 hours 12 minutes remaining</label>
					</li> -->
				</ul>
			</div>
		</div>
	</div>
	<!-- Processor Details Dialog -->
	<div class="gtkdialog" id="processorDetailedViewDialog">
		<div class="gtkdialog-window large">
			<div class="titlebar" title="Processor">
				<div class="button-group float-right">
					{%- include components/close-button.html close = "gtkdialog" -%}
				</div>
			</div>
			<div class="gtkdialog-content">
				<div class="row">
					<div class="sysmonActivityCanvas">
						<div class="float-left">
							<span class="sysmonCPUActivityCPUName"><b>CPU1</b></span>
							<canvas id="host1Cpu" width="224" height="128"></canvas>
						</div>
						<div class="float-right">
							<span class="sysmonCPUActivityCPUName"><b>CPU2</b></span>
							<canvas id="host2Cpu" width="224" height="128"></canvas>
						</div>
						<div class="float-left">
							<span class="sysmonCPUActivityCPUName"><b>CPU3</b></span>
							<canvas id="host3Cpu" width="224" height="128"></canvas>
						</div>
						<div class="float-right">
							<span class="sysmonCPUActivityCPUName"><b>CPU4</b></span>
							<canvas id="host4Cpu" width="224" height="128"></canvas>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<script type="text/javascript">

// random values
function addRandomValueToDataSets(time, dataSets) {
  for (var i = 0; i < dataSets.length; i++) {
    dataSets[i].append(time, Math.random());
  }
}

// CPU Graph
function sysmonCPUActivity() {
  initCPUHost('host1');
  initCPUHost('host2');
  initCPUHost('host3');
  initCPUHost('host4');
}

var seriesOptionsCPU = [
  { strokeStyle: 'rgba(53, 132, 228, 1)', fillStyle: 'rgba(53, 132, 228, 0)', lineWidth: 1 },
  { strokeStyle: 'rgba(51, 209, 122, 1)', fillStyle: 'rgba(51, 209, 122, 0)', lineWidth: 1 },
  { strokeStyle: 'rgba(255, 120, 0, 1)', fillStyle: 'rgba(255, 120, 0, 0)', lineWidth: 1 },
  { strokeStyle: 'rgba(244, 27, 36, 1)', fillStyle: 'rgba(244, 27, 36, 0)', lineWidth: 1 }
];

function initCPUHost(hostId) {

  // Initialize an empty TimeSeries for each CPU.
  // var cpuDataSets = [new TimeSeries()];
  var cpuDataSets = [new TimeSeries(), new TimeSeries(), new TimeSeries(), new TimeSeries()];

  var now = new Date().getTime();
  for (var t = now - 1000 * 50; t <= now; t += 1000) {
    addRandomValueToDataSets(t, cpuDataSets);
  }
  // Every second, simulate a new set of readings being taken from each CPU.
  setInterval(function() {
    addRandomValueToDataSets(new Date().getTime(), cpuDataSets);
  }, 1000);

  // Build the timeline
  var timeline = new SmoothieChart({ millisPerPixel: 100,labels:{disabled:true}, grid: {fillStyle:'rgba(0,0,0,0)',sharpLines:true,borderVisible:false,strokeStyle: '#ddd', lineWidth: 1, millisPerLine: 10000, verticalSections: 4 }});
  for (var i = 0; i < cpuDataSets.length; i++) {
    timeline.addTimeSeries(cpuDataSets[i], seriesOptionsCPU[i]);
  }
  timeline.streamTo(document.getElementById(hostId + 'Cpu'), 500);
}

// Memory Graph
function sysmonMemoryActivity() {
  initMemoryHost('host1');
  initMemoryHost('host2');
}

var seriesOptionsMemory = [
  { strokeStyle: 'rgba(233, 77, 223, 1)', fillStyle: 'rgba(233, 77, 223, 0)', lineWidth: 1 },
  { strokeStyle: 'rgba(53, 132, 228, 1)', fillStyle: 'rgba(53, 132, 228, 0)', lineWidth: 1 }
];

function initMemoryHost(hostId) {

  // Initialize an empty TimeSeries for each CPU.
  // var networkDataSets = [new TimeSeries()];
  var memoryDataSets = [new TimeSeries(), new TimeSeries()];

  var now = new Date().getTime();
  for (var t = now - 1000 * 50; t <= now; t += 1000) {
    addRandomValueToDataSets(t, memoryDataSets);
  }
  // Every second, simulate a new set of readings being taken from each CPU.
  setInterval(function() {
    addRandomValueToDataSets(new Date().getTime(), memoryDataSets);
  }, 1000);

  // Build the timeline
  var timeline = new SmoothieChart({ millisPerPixel:10,interpolation:'step',maxValueScale:8,minValueScale:8,labels:{disabled:true}, grid: {fillStyle:'rgba(0,0,0,0)',sharpLines:true,borderVisible:false,strokeStyle: '#ddd', lineWidth: 1, millisPerLine: 10000, verticalSections: 4 }});
  for (var i = 0; i < memoryDataSets.length; i++) {
    timeline.addTimeSeries(memoryDataSets[i], seriesOptionsMemory[i]);
  }
  timeline.streamTo(document.getElementById(hostId + 'Memory'), 1000);
}

// Networking Graph
function sysmonNetworkActivity() {
  initNetworkHost('host1');
  initNetworkHost('host2');
}

var seriesOptionsNetworking = [
  { strokeStyle: 'rgba(244, 27, 36, 1)', fillStyle: 'rgba(244, 27, 36, 0)', lineWidth: 1 },
  { strokeStyle: 'rgba(53, 132, 228, 1)', fillStyle: 'rgba(53, 132, 228, 0)', lineWidth: 1 }
];

function initNetworkHost(hostId) {

  // Initialize an empty TimeSeries for each CPU.
  // var networkDataSets = [new TimeSeries()];
  var networkDataSets = [new TimeSeries(), new TimeSeries()];

  var now = new Date().getTime();
  for (var t = now - 1000 * 50; t <= now; t += 1000) {
    addRandomValueToDataSets(t, networkDataSets);
  }
  // Every second, simulate a new set of readings being taken from each CPU.
  setInterval(function() {
    addRandomValueToDataSets(new Date().getTime(), networkDataSets);
  }, 1000);

  // Build the timeline
  var timeline = new SmoothieChart({ millisPerPixel:70,interpolation:'linear',labels:{disabled:true}, grid: {fillStyle:'rgba(0,0,0,0)',sharpLines:true,borderVisible:false,strokeStyle: '#ddd', lineWidth: 1, millisPerLine: 1000, verticalSections: 4 }});
  for (var i = 0; i < networkDataSets.length; i++) {
    timeline.addTimeSeries(networkDataSets[i], seriesOptionsNetworking[i]);
  }
  timeline.streamTo(document.getElementById(hostId + 'Network'), 1000);
}
</script>